"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = require("react");
var _store_1 = __importDefault(require("./_store"));
var wrapTWithDefaultNs_1 = __importDefault(require("./wrapTWithDefaultNs"));
var context_1 = __importDefault(require("./context"));
var transCore_1 = __importDefault(require("./transCore"));
function useTranslationInPages(defaultNS) {
    var ctx = (0, react_1.useContext)(context_1.default);
    return (0, react_1.useMemo)(function () { return (__assign(__assign({}, ctx), { t: (0, wrapTWithDefaultNs_1.default)(ctx.t, defaultNS) })); }, [ctx, defaultNS]);
}
function useTranslationAppDir(defaultNS) {
    var _a = _store_1.default.get(), lang = _a.lang, namespaces = _a.namespaces, config = _a.config;
    var localesToIgnore = config.localesToIgnore || ['default'];
    var ignoreLang = localesToIgnore.includes(lang);
    var t = (0, transCore_1.default)({
        config: config,
        allNamespaces: namespaces,
        pluralRules: new Intl.PluralRules(ignoreLang ? undefined : lang),
        lang: lang,
    });
    return { t: (0, wrapTWithDefaultNs_1.default)(t, defaultNS), lang: lang };
}
function useTranslation(defaultNS) {
    var appDir = _store_1.default.get();
    var useT = (appDir === null || appDir === void 0 ? void 0 : appDir.config) ? useTranslationAppDir : useTranslationInPages;
    return useT(defaultNS);
}
exports.default = useTranslation;
